component {
	this.cds=[];
	this.cd={};
	this.insideCD=false;
	this.currentName="";
	this.filter={};
	this.removeCD=false;

	/**
	* constructor of the component that takes the path to the xml file and a simple custom made filter
	* @param xmlFile xml File to parse
	* @param filter filter to limit content on certain records
	*/
	function init(string xmlFile, struct filter={}) {
		var xmlEventParser=createObject("java","lucee.runtime.helpers.XMLEventParser");
		this.filter=filter;
		// registering the event handlers
		xmlEventParser.init(
			getPageContext(),
			this.startDocument,
			this.startElement,
			this.body,
			this.endElement,
			this.endDocument,
			this.error
		);
		xmlEventParser.start(xmlFile);
		return this.cds;
	}

	/**
	* this function will be called on start parsing a XML Element (Tag)
	*/
	function startElement(string uri, string localName, string qName, struct attributes){
		if(localName EQ "cd"){
			this.cd={};
			this.insideCD=true;
			this.removeCD=false;

		}
		else if(this.insideCD){
			this.currentName=localName;
		}
	}

	/**
	* call with body of the tag
	*/
	function body(string content){
		if(len(this.currentName)) {
			this.cd[this.currentName]=content;
			if(structKeyExists(this.filter,this.currentName) and content NEQ this.filter[this.currentName])
				this.removeCD=true;
		}
	}

	/**
	* this function will be called on end parsing a XML Element (Tag)
	*/
	function endElement(string uri, string localName, string qName, struct attributes){
		if(localName EQ "cd") {
			if(!this.removeCD)
				this.cds[arrayLen(this.cds)+1]=this.cd;
			this.insideCD=false;
		}
		this.currentName="";
	}

	/**
	* this function will be called on start parsing document
	*/
	function startDocument(string uri, string localName, string qName, struct attributes){
	}

	/**
	* this function will be called on end parsing document
	*/
	function endDocument(string uri, string localName, string qName, struct attributes){
	}

	/**
	* this function will be called wgen a error occur
	*/
	function error(struct cfcatch){
		dump(cfcatch);
	}
}